/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/* ***************************************************** */
/********************************************************************/
/**
 * @file CurveFillet.h
 * @brief MGCurveFilletTool クラスのインターフェイス
 */
#if !defined(AFX_CURVEFILLET_H__4D46A5A2_1A5F_4CA0_8FD1_BBF489BA35CD__INCLUDED_)
#define AFX_CURVEFILLET_H__4D46A5A2_1A5F_4CA0_8FD1_BBF489BA35CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/SelectState.h"

/// @class MGCurveFilletTool CurveFillet.h CurveCmd/CurveFillet.h
/// 
/// Fillets two curves.
class MGCurveFilletTool : public MGSelectState{
public:
	explicit MGCurveFilletTool(fugenDoc* pDoc);

	virtual MGCommandBase* initial_clone(fugenDoc* pDoc)const;
	virtual bool initiate_tool();
	virtual bool terminate_tool(bool cancel = false);
	virtual bool OnKeyDown(fugenView*, UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual bool OnSelected(fugenView* pView, MGPickObjects&, MGPickObjects&);
	
private:
	bool calculate();
	bool input_param();
	void prompt_message() const;

	MGPickObject m_curve1; ///< 対象曲線その1
	MGPickObject m_curve2; ///< 対象曲線その2
	double m_dRadius; // フィレット半径{>=0}
	UINT m_nIDS; ///< エラーメッセージ
	bool m_bJoin; ///< 生成曲線を接合するかどうか
	bool m_bTrim; ///< 元の曲線をトリムする(or計算時の一時延長を使う)かどうか
};

#endif // !defined(AFX_CURVEFILLET_H__4D46A5A2_1A5F_4CA0_8FD1_BBF489BA35CD__INCLUDED_)
